Imports System.Security.Principal
Imports System.DirectoryServices
Imports System.Runtime.InteropServices
Imports Microsoft.Interop.Security.AzRoles

Public Class AdamIdentity
  Implements IIdentity


  Private ReadOnly m_name As String
  Private ReadOnly m_AdamUserDirectoryEntry As DirectoryEntry

  Public Property Personalization(ByVal key As String) As Object
    Get
      Dim l_DirectorySearcher As New DirectorySearcher(m_AdamUserDirectoryEntry, _
      "(CN=" + key + ")")
      Dim l_SearchResult As SearchResult = l_DirectorySearcher.FindOne()
      If l_SearchResult Is Nothing Then _
        Throw New Exception(key + " not found")
      Return l_SearchResult.GetDirectoryEntry.Properties("SS-personalizationattr").Item(0)
    End Get
    Set(ByVal Value As Object)
      Dim l_DirectorySearcher As New DirectorySearcher(m_AdamUserDirectoryEntry, _
      "(CN=" + key + ")")
      Dim l_SearchResult As SearchResult = l_DirectorySearcher.FindOne()
      If l_SearchResult Is Nothing Then _
        Throw New Exception(key + " not found")
      l_SearchResult.GetDirectoryEntry.Properties("SS-personalizationattr").Item(0) = Value
    End Set
  End Property


  Friend Sub New(ByVal p_name As String, ByVal p_AdamUserDirectoryEntry As DirectoryEntry)
    m_name = p_name
    m_AdamUserDirectoryEntry = p_AdamUserDirectoryEntry
  End Sub


  Public ReadOnly Property AuthenticationType() As String Implements System.Security.Principal.IIdentity.AuthenticationType
    Get
      Return "ADAM"
    End Get
  End Property

  Public ReadOnly Property IsAuthenticated() As Boolean Implements System.Security.Principal.IIdentity.IsAuthenticated
    Get
      Return True
    End Get
  End Property

  Public ReadOnly Property Name() As String Implements System.Security.Principal.IIdentity.Name
    Get
      Return m_name
    End Get
  End Property
End Class